
Ruby - Bug #12044

net/ftp.rb: add NullSocket#closed? to fix closing not yet opened connection

02/01/2016 10:52 PM - antstorm (Anthony Dmitriyev)

Status: Closed   

Priority: Normal   

Assignee: core   

Target version:    

ruby -v: ruby 2.3.0p0 (2015-12-25 revision

53290) [x86_64-darwin14]

Backport: 2.1: DONE, 2.2: DONE, 2.3: DONE

Description

Hi there,

I've opened a PR for this issue on GitHub: https://github.com/ruby/ruby/pull/1232

An instance of NullSocket is stored in a @sock variable of a new Net::FTP, it also has a #close method (that obviously does nothing),

but it is never called, because a wrapping Net::FTP#close checks that @sock and not @sock.closed? which crashes with

FTPConnectionError because there is no method #closed? on NullSocket. This PR adds it and a test to verify that it works.

Below is the way to reproduce the error in the IRB. As you can see it's quite confusing, you'd expect #closed? not to raise an error,

but return true instead.

>> ftp = Net::FTP.new

=> #<Net::FTP:0x007f90c38075e0 @mon_owner=nil, @mon_count=0, @mon_mutex=#<Thread::Mutex:0x007f90c3

807590>, @binary=true, @passive=true, @debug_mode=false, @resume=false, @sock=#<Net::FTP::NullSock

et:0x007f90c3807568>, @logged_in=false, @open_timeout=nil, @read_timeout=60>

>> ftp.close

Net::FTPConnectionError: not connected

 from /usr/local/var/rbenv/versions/2.3.0/lib/ruby/2.3.0/net/ftp.rb:1277:in `method_missing'

 from /usr/local/var/rbenv/versions/2.3.0/lib/ruby/2.3.0/net/ftp.rb:1168:in `close'

 from (irb):6

 from /usr/local/var/rbenv/versions/2.3.0/bin/irb:11:in `<main>'

>> ftp.closed?

Net::FTPConnectionError: not connected

 from /usr/local/var/rbenv/versions/2.3.0/lib/ruby/2.3.0/net/ftp.rb:1277:in `method_missing'

 from /usr/local/var/rbenv/versions/2.3.0/lib/ruby/2.3.0/net/ftp.rb:1184:in `closed?'

 from (irb):7

 from /usr/local/var/rbenv/versions/2.3.0/bin/irb:11:in `<main>'

Associated revisions

Revision fb28e643423b08fb8b0b458cca7799992d8df156 - 03/25/2016 09:31 AM - U.Nakamura 

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@54277 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision fb28e643 - 03/25/2016 09:31 AM - U.Nakamura 

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@54277 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5840a393fb80342e5b389725ab7a9fddcb2189f7 - 03/28/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]
 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54330 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5840a393 - 03/28/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54330 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b2ac0f9c7d8ce2aee4730a5ccc4f35a17a1d36d9 - 03/29/2016 07:29 AM - naruse (Yui NARUSE)

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54377 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b2ac0f9c - 03/29/2016 07:29 AM - naruse (Yui NARUSE)

merge revision(s) 53810: [Backport #12044]

    * net/ftp.rb: add NullSocket#closed? to fix closing not opened

      connection.  [Fix GH-1232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54377 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/04/2016 07:24 AM - naruse (Yui NARUSE)

- Status changed from Open to Closed

fixed at r53810

#2 - 03/24/2016 07:19 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: REQUIRED, 2.2: REQUIRED, 2.3:

REQUIRED

#3 - 03/25/2016 09:31 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: DONE, 2.2: REQUIRED, 2.3: REQUIRED

ruby_2_1 r54277 merged revision(s) 53810.

#4 - 03/28/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: DONE, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: DONE, 2.2: DONE, 2.3: REQUIRED

Backported into ruby_2_2 branch at r54330.

#5 - 03/29/2016 07:29 AM - naruse (Yui NARUSE)

- Backport changed from 2.1: DONE, 2.2: DONE, 2.3: REQUIRED to 2.1: DONE, 2.2: DONE, 2.3: DONE

ruby_2_3 r54377 merged revision(s) 53810.
